<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta http-equiv="x-ua-compatible" content="ie=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <script src="/jquery-3.5.1.min.js"></script>

    <title>FM-SDR</title>

    <style>

      input[type=number]{
          width: 80px;
      } 

      td {
        background: #eee;
        margin: 5px;
        padding: 10px;
      }

      .red {
        color: red;
      }

      .green {
        color: green;
      }
    </style>
  </head>

  <body>
    <h3>FM-SDR</h3>

    <table>
      <tr><td>Connected to device:</td><td><span id="connected" class="red">NO</span></td></tr>
      <tr><td>Frequency:</td>       <td><input id="freq" class="ctrl" type="number" step="0.1" size="6" disabled /> Mhz</td></tr>
      <tr><td>Volume:</td>          <td><input id="volume" class="ctrl" type="number" step="1" size="6" disabled /> %</td></tr>
      <tr><td>De-emphasis ON:</td>    <td><input id="deemp" class="ctrl" type="checkbox" disabled /></td></tr>
      <tr><td>Amplifier ON:</td>    <td><input id="amp" class="ctrl" type="checkbox" disabled /></td></tr>
      <tr><td colspan="2">
        <button id="poweroff" class="ctrl" disabled>POWEROFF</button>
        &nbsp;
        <button id="reboot" class="ctrl" disabled>REBOOT</button></td></tr>
    </table>

    <script>
      
      lock = {
        "freq": false,
        "volume": false,
        "amp": false,
        "deemp": false,
      }


      function getState() 
      {
        // NEW STATE
        $.get( "/state", (data) => {
          console.log("state", data)

          /*if (!lock['freq'])    $('#freq').val(data['freq_m'])
          if (!lock['volume'])  $('#volume').val(data['volume'])
          if (!lock['amp'])     $('#amp').prop( "checked", data['amp'])*/
          if (!$('#freq').is(":focus"))    $('#freq').val(data['freq_m'])
          if (!$('#volume').is(":focus"))  $('#volume').val(data['volume'])
          if (!$('#amp').is(":focus"))     $('#amp').prop( "checked", data['amp'])
          if (!$('#deemp').is(":focus"))     $('#deemp').prop( "checked", data['deemp'])

          $('.ctrl').prop( "disabled", false );
          $('#connected').removeClass("red").addClass("green")
          $('#connected').html("YES")
        })
        
        // LINK EROR
        .fail((error) => {
          console.log("error", error)
          $('.ctrl').prop( "disabled", true );
          $('#connected').removeClass("green").addClass("red")
          $('#connected').html("NO")
        })

        // RESTART
        .always(() => {
          setTimeout(getState, 1000)
        });
      }


      // RUN
      $(function() {

          getState()

          $('#freq').on("change keyup", ()=>{
            if (lock['freq']) clearTimeout(lock['freq'])
            lock['freq'] = setTimeout(()=>{
              $.get( "/frequency/mhz/"+$('#freq').val(), () => { /*done*/ })   
                .always(() => { lock['freq'] = null; console.log('unlocked') });
            }, 400)
            console.log('locked')
          })

          $('#volume').on("change keyup", ()=>{
            if (lock['volume']) clearTimeout(lock['volume'])
            lock['volume'] = setTimeout(()=>{
              $.get( "/volume/"+$('#volume').val(), () => { /*done*/ })   
                .always(() => { lock['volume'] = null; console.log('unlocked') });
            }, 400)
            console.log('locked')
          })

          $('#amp').on("change keyup", ()=>{
            if (lock['amp']) clearTimeout(lock['amp'])
            lock['amp'] = setTimeout(()=>{
              if ($('#amp').is(':checked')) amp = 'on'
              else amp = 'off'
              $.get( "/amp/"+amp, () => { /*done*/ })   
                .always(() => { lock['amp'] = null; console.log('unlocked') });
            }, 400)
            console.log('locked')
          })

          $('#deemp').on("change keyup", ()=>{
            if (lock['deemp']) clearTimeout(lock['deemp'])
            lock['deemp'] = setTimeout(()=>{
              if ($('#deemp').is(':checked')) deemp = 'on'
              else deemp = 'off'
              $.get( "/deemp/"+deemp, () => { /*done*/ })   
                .always(() => { lock['deemp'] = null; console.log('unlocked') });
            }, 400)
            console.log('locked')
          })

          $('#reboot').on('click', ()=>{
            if (confirm("Reboot ?")) $.get( "/reboot", () => { /*done*/ })
          })

          $('#poweroff').on('click', ()=>{
            if (confirm("Power OFF ?")) $.get( "/poweroff", () => { /*done*/ })
          })

      });



    </script>
  </body>
</html>